/*
 * Created on 2004/08/13
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.wavconvert;

import java.io.File;
import java.util.Hashtable;

import org.eclipse.swt.SWT;

import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;
import org.jpn.xucker.commons.swt.series.wfs.WrapperExecuter;
import org.jpn.xucker.commons.swt.series.wfs.WrapperFileStandard;
import org.jpn.xucker.commons.swt.series.wfs.WrapperFileStandardSettingDialog;
import org.jpn.xucker.commons.swt.ui.GroupCheckTreeContoler;




/**
 * 
 *  
 */
public class SoxWrapper extends WrapperFileStandard {

    Button confirmOverwrite;

    RadioFormatGroup radioFormatGroup;
    /**
     * @param shell
     */
    public SoxWrapper(Shell shell) {
        super(shell);
        
    }

    public static void main(String[] args) {
       
        Display display = new Display();
        Shell shell = new Shell(display, SWT.CLOSE | SWT.MIN);

        try {
            SoxWrapper main = new SoxWrapper(shell);

            shell.open();
            shell.setSize(500,430);
            while (!shell.isDisposed()) {
                if (!display.readAndDispatch()) {
                    display.sleep();
                }
            }
            display.dispose();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (!shell.isDisposed()) {
                shell.close();
            }

            display.dispose();
            //System.exit(0);
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.wfs.WrapperFileStandard#beforeInit()
     */

    public static String WAVE_FORMAT_EXTENSIVE = "WAVE_FORMAT_EXTENSIVE";
    private Shell childshell;

    public static String rateLabel[]={" 8.0khz","11.0khz","12.0khz","16.0khz","22.0khz","24.0khz","32.0khz","44.1khz","48.0khz"};
    public static int rateInt[]={8000,11025,12000,16000,22050,24000,32000,44100,48000};
    protected void beforeInit() {
        // TODO Auto-generated method stub
        APP_NAME = "WavConvert with sox(Wavϊ)";
        defaultCommandPath = "sox.exe";
        logoPath = "org/jpn/xucker/wavconvert/resource/logo.png";
        iconPath = "org/jpn/xucker/wavconvert/resource/icon.png";
        settingLabel = "wavConvertݒ";
        exeName = "sox.exe";
        allowFileExtension = new String[] { "wav","aiff","au"};
        execLabel = "ϊ";
        myselfExeName = "wavconvert.exe";
        url = "http://www.xucker.jpn.org/product/wavconvert.html";
        version = 0.2;
        resultLabels=new String[]{"","t@CTCY","t@C","fBNg["};
        resultWidths=new int[]{50,50,75,75};
        outputExtension=".wav";
        radioFormatGroup=new RadioFormatGroup();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.wfs.WrapperFileStandard#afterInit()
     */
    protected void afterInit() {
        table_rowdata.height=60;
        option_rowdata.height=150;
        confirmOverwrite = new Button(optionGroup, SWT.NULL | SWT.CHECK);
        confirmOverwrite.setText("㏑Ƀ_CAO\Ȃ");
        confirmOverwrite.setSelection(false);
        confirmOverwrite.addSelectionListener(this);
        RowData dobackup_data = new RowData();
        confirmOverwrite.setLayoutData(dobackup_data);
        
        folder = new TabFolder(optionGroup,SWT.NULL);
        RowData treedata=new RowData();
        treedata.width=465;
        treedata.height=100;
        folder.setLayoutData(treedata);
        
        listTab = new TabItem(folder,SWT.NULL);
        listTab.setText("yXo");
        
        Composite composite=new Composite(folder,SWT.NULL);
        composite.setLayout(new RowLayout());
        listTab.setControl(composite);
        
        createAudioSelectItem(composite);
        
        multiItem = new TabItem(folder,SWT.NULL);
        multiItem.setText("}`Wavo");
        
        
        
        Tree tree=new Tree(folder,SWT.CHECK);
        tree.addSelectionListener(this);
        multiItem.setControl(tree);
        
        
        rootTree = new TreeItem(tree,SWT.NULL);
        formatHash=new Hashtable();
        
        rootTree.setText("ׂ");
        TreeItem stereo=new TreeItem(rootTree,SWT.NULL);
        stereo.setText("XeI");
        createTreeItem(stereo,true);
        TreeItem mono=new TreeItem(rootTree,SWT.NULL);
        mono.setText("m");
        createTreeItem(mono,false);
       
        
        checkTreeControler = new GroupCheckTreeContoler(tree);
    }
    
    /**
     * @param composite
     */
    private void createAudioSelectItem(Composite composite) {
       createFormat(composite,"Wav Mono(16bit 44.1khz m)",new AudioFormat(AudioFormat.WAV,16,44100,1)); 
       createFormat(composite,"Wav Monoቹ(16bit 16.0khz m)",new AudioFormat(AudioFormat.WAV,16,16000,1)); 
       
       createFormat(composite,"Wav CD`(16bit 44.1khz XeI)",new AudioFormat(AudioFormat.WAV,16,44100,2)); 
       
       createFormat(composite,"Au Java`(8bit 8khz m)",new AudioFormat(AudioFormat.AU,8,8000,1));
       //how to select. how to set type?
       radioFormatGroup.selectValue("Wav Mono(16bit 44.1khz m)");
    }
    
    private void createFormat(Composite composite,String label,AudioFormat format){
       
        Button typeButton=new Button(composite,SWT.RADIO);
        typeButton.setText(label);
        radioFormatGroup.addRadio(typeButton,label,format);
    }
    
    public class RadioFormatGroup{
        Hashtable formatHash=new Hashtable();
        Hashtable buttonHash=new Hashtable();
        public void addRadio(Button bt,String label,AudioFormat format){
        buttonHash.put(label,bt);
        formatHash.put(label,format);
        }
        
        public void selectValue(String value){
            String keys[]=(String[])buttonHash.keySet().toArray(new String[buttonHash.size()]);
            for(int i=0;i<keys.length;i++){
               
                if(keys[i].equals(value)){
                    Button bt=(Button)buttonHash.get(keys[i]);
                    bt.setSelection(true);
                    break;
                }
            }
        }
        public AudioFormat getAudioFormat(){
            AudioFormat format=null;
            String value=getValue();
            if(value!=null){
                format=(AudioFormat)formatHash.get(value);
            }
            return format;
        }
        public String getValue(){
            String result=null;
            String keys[]=(String[])buttonHash.keySet().toArray(new String[buttonHash.size()]);
            for(int i=0;i<keys.length;i++){
                Button bt=(Button)buttonHash.get(keys[i]);
                if(bt.getSelection()){
                    result=keys[i];
                    break;
                }
            }
            return result;
        }
    }

    private Hashtable formatHash;
    private GroupCheckTreeContoler checkTreeControler;

    private TabItem multiItem;

    private TabItem listTab;

    private TabFolder folder;

    private TreeItem rootTree;
    public void createTreeItem(TreeItem parent,boolean isStereo){
       
        TreeItem item8=new TreeItem(parent,SWT.NULL);
        item8.setText(" 8rbg");
        item8.setGrayed(false);
        TreeItem item16=new TreeItem(parent,SWT.NULL);
        item16.setText("16rbg");
        
        for(int i=0;i<rateLabel.length;i++){
            TreeItem child=new TreeItem(item8,SWT.NULL);
            child.setText(rateLabel[i]);
            AudioFormat format=new AudioFormat();
            format.setType(AudioFormat.WAV);
            if(isStereo){
                format.setChannel(2);
                
            }
            format.setBit(8);
            format.setRate(rateInt[i]);
            formatHash.put(child,format);
            
            TreeItem child16=new TreeItem(item16,SWT.NULL);
           
            child16.setText(rateLabel[i]);
            AudioFormat format16=new AudioFormat();
            format16.setType(AudioFormat.WAV);
            if(isStereo){
                format16.setChannel(2);
                
            }
            format16.setBit(16);
            format16.setRate(rateInt[i]);
            formatHash.put(child16,format16);
        }
         
        
    }


    /*
     * (non-Javadoc)
     * 
     * @see org.jpn.xucker.commons.swt.series.wfs.WrapperFileStandard#createWrapperExecuter()
     */
    protected WrapperExecuter createWrapperExecuter() {
        SoxExecuter executer = new SoxExecuter();
        executer.setWrapper(this);

        if(folder.getSelection()[0]==listTab){
        //add Type
        executer.addAudioFormat(radioFormatGroup.getAudioFormat());
        }else{
           
            TreeItem[] items=checkTreeControler.getSelectedLeafItem(rootTree);
            for (int i = 0; i < items.length; i++) {
                AudioFormat format=(AudioFormat)formatHash.get(items[i]);
                if(format!=null){
                    executer.addAudioFormat(format);
                }else{
                    System.out.println("warning:format==null");
                }
            }
        }
        //executer.setShowOnly(true);
        executer.setDebug(true);
        executer.setPrint(true);
        
        if (confirmOverwrite.getSelection()) {
           executer.setOverwrite(true);
        }
        
        return executer;
    }

    public void openProperty() {
        if(childshell==null || childshell.isDisposed()){
        childshell = new Shell(shell);
        WrapperFileStandardSettingDialog dialog = new WrapperFileStandardSettingDialog(
                this, childshell);
        dialog.setExeName(exeName);
        dialog.setCommandLabel(exeName + "pX");
        
        

        dialog.createGUI();
        dialog.createOkCancellButton();
        if (fileProperties != null) {
            if (fileProperties.get(COMMAND_PATH) != null) {
                dialog.setCommandPath(fileProperties.get(COMMAND_PATH));
            }
        }
        childshell.open();
        }else{
            childshell.setFocus();
        }
    }

    /**
     * @param tmpOutput
     * @return
     */
    public boolean doOverwriteDialog(File output) {
        boolean result=false;
        //call dialog
        OverwriteDialog overwriteDialog=new OverwriteDialog(output);
        shell.getDisplay().syncExec(overwriteDialog);
        //get result;
        result=overwriteDialog.isResult();
        return result;
    }
    
    public class OverwriteDialog extends Thread{
        private File file;
        private boolean result;
        public File getFile() {
            return file;
        }
        public void setFile(File file) {
            this.file = file;
        }
        public boolean isResult() {
            return result;
        }
        public void setResult(boolean result) {
            this.result = result;
        }
        public OverwriteDialog(File file){
            this.file=file;
        }
        public void run(){
           MessageBox box=new MessageBox(shell,SWT.YES|SWT.NO);
           box.setText("t@C㏑܂?");
           box.setMessage("t@C "+file.getAbsolutePath()+"͂łɑ݂܂B㏑܂?");
           int ret=box.open();
           
           if(ret==SWT.YES){
               result=true;
           }
        }
    }

}